(* We can also hide the implementation of the data structure by 
	specifying a particular module type. *)

module type INTSET = 
sig 
  type element = int  (* A concrete type *)
  val int_compare : int -> int -> comparison
	 
  type set  (* An abstract type *)
		
  val empty : int list
  val add : element -> set -> set
  val member : element -> set -> bool 
end 

module AbsIntSet = (IntSet : INTSET);;

(* 
  let set = AbsIntSet.add 2 
     (AbsIntSet.add 3 (AbsIntSet.add 4 AbsIntSet.empty))
  in AbsIntSet.member 4 set || AbsIntSet.is_empty set;;
*)

(*
  IntSet.add 3 (IntSet.empty);;
  IntSet.add 3 (AbsIntSet.empty);;
*)


